# OGRP Django Project

This is a Django project.

## Requirements

- Python 3.6+
- Django 3.8+

## Installation

Follow these steps to set up and run the project.

### 1.  Clone the repository

```sh
git clone https://github.com/zijian-yu/OGRP.git
cd yourprojectname
```

### 2.  Create a virtual environment

It's recommended to use a virtual environment to manage dependencies.  You can create one using `venv`:

```sh
python3 -m venv venv
```

Activate the virtual environment:

- On Windows:

```sh
venv\Scripts\activate
```

- On Unix or MacOS:

```sh
source venv/bin/activate
```

### 3.  Install dependencies

Install the required Python libraries from `requirements.txt`:

```sh
pip install -r requirements.txt
```

### 4.  Run database migrations

Make sure your database is set up and configured in your `settings.py` file.  Then, run the following command to apply migrations:

```sh
python manage.py migrate
```

### 5.  Run the server

Start the Django development server:

```sh
python manage.py runserver
```

You can now access the project at `http://127.0.0.1:8000/`.

## Contributing

1.  Fork the repository.
2.  Create a new branch: `git checkout -b my-feature-branch`
3.  Make your changes and commit them: `git commit -m 'Add some feature'`
4.  Push to the branch: `git push origin my-feature-branch`
5.  Submit a pull request.

## Copyright
© [2024] College of Life Science, North China University of Science and Technology.  All rights reserved.
